# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define _with_repolib 1

%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repodir %{_javadir}/repository.jboss.com/org/jboss/cluster/jboss-ha-server-api/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define namedversion %{version}.Final
%define oname jboss-ha-server-api

Name:           jboss-cluster-ha-server-api
Version:        1.2.1
Release:        2%{?dist}
Epoch:          0
Summary:        JBoss HA Server API
License:        LGPL
Group:          Development/Java
URL:            http://www.jboss.org/
# svn export http://anonsvn.jboss.org/repos/jbossas/projects/cluster/ha-server-api/tags/1.2.1.Final jboss-cluster-ha-server-api-1.2.1/
# Exported revision 113409.
# tar czf jboss-cluster-ha-server-api-1.2.1.tar.gz jboss-cluster-ha-server-api-1.2.1
Source0:        jboss-cluster-ha-server-api-%{version}.tar.gz
Source1:        jboss-cluster-ha-server-api-jpp-depmap.xml
Source2:        jboss-cluster-ha-server-api-settings.xml
Source5:	%{name}-component-info.xml
Source6: 	jboss-cluster-ha-server-api-upload.sh
 
BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  codehaus-stax11-api
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-release
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:	dtdparser
BuildRequires:  easymock2
BuildRequires:  junit
BuildRequires:  jboss-aspects-build

# optional
BuildRequires:  jboss-aop2
BuildRequires:  jboss-cache-core
BuildRequires:  jboss-cache-pojo
BuildRequires:  jgroups
# required
BuildRequires:  jboss-common-core
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-cluster-ha-client
BuildRequires:	jboss-parent
BuildRequires:	xerces-j2
# runtime minimal
Requires:  java >= 0:1.5.0
Requires:  jboss-common-core
Requires:  jboss-common-logging-spi
Requires:  jboss-cluster-ha-client

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss HA server API.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%if %{with_repolib}
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

%prep
%setup -q 

find . -name "*.jar" -exec rm -f {} \;

%build
cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.skip=true \
        install javadoc:javadoc

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 target/%{oname}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
%add_to_maven_depmap org.jboss.cluster %{oname} %{namedversion} JPP %{name}
install -m 644 target/%{oname}-sources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar

jar -cf $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar -C target/site/apidocs/ .

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# pom
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf target/site/apidocs/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%if %{with_repolib}
tag=`echo %{namedversion}-brew`
sed -i "s/@VERSION@/$tag/g" %{SOURCE5}
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE5}
        install -d -m 755 $RPM_BUILD_ROOT%{repodir}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
        install -m 755 %{SOURCE5} $RPM_BUILD_ROOT%{repodir}/component-info.xml
        install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE1} $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{repodirsrc}
        cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}.jar
	cp -p pom.xml $RPM_BUILD_ROOT%{repodirlib}/%{name}.pom
        cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-sources.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}-sources.jar
        cp -p $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}-javadoc.jar $RPM_BUILD_ROOT%{repodirlib}/%{name}-javadoc.jar

install -p -m 755 %{SOURCE6} %{buildroot}%{repodir}/upload.sh
pushd %{buildroot}%{repodir}
./upload.sh %{buildroot}/usr/share/java/repository.jboss.com/maven2-brew/
popd

%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/*jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{_javadir}/repository.jboss.com
%endif

%changelog
* Tue Aug 07 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2.1-2
- Refresh sources for fix in pom (version)

* Tue Aug 07 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.2.1-1
- Upgrade to 1.2.1.Final

* Tue Mar 01 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.2.0-1.1
- Upgrade to 1.2.0.Final

* Mon Jan 24 2011 Permaine Cheung <pcheung@redhat.com> - 0:1.1.3-1.3
-Rebuild

* Wed Nov 24 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.1.3-1.2
- Fix upload.sh to include sources.jar and javadoc.jar

* Mon Nov 22 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.1.3-1.1
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Fix %%files for signed jars
- Add content of maven2-brew
- Add the line to find and remove any binaries
- Add BR maven-release-plugin, jboss-aspects-build, codehaus-stax11-api

* Wed Jun 02 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.1.3-1
- Merge from RHEL4

* Tue Jun 01 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.1.3-1
- Upgrade to 1.1.3.Final
- Add BR dtdparser, xerces-j2

* Wed May 19 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.1.2-2
- Add BR jboss-parent and remove its pom.xml from sources

* Wed May 19 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.1.2-1
- Upgrade to 1.1.2.Final

* Thu May 06 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.1.1-2.4.1
- rebuilt

* Thu Apr 08 2010 Hui Wang <huwang@redhat.com> - 0:1.1.1-2.4
- Rebuild

* Mon Nov 16 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.1.1-2.3
- Add repolib
- Add sources.jar to main package and repolib
- Add component-info.xml

* Thu Aug 20 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.1.1-2.2
- Enable jboss-cache-pojo classes

* Thu Aug 20 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.1.1-2.1
- Comment BR jboss-cache-pojo and add patch to remove from pom file
- Remove classes that depend on jboss-cache-pojo
- Change location of jboss-parent pom file

* Sat Jul 25 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.1.1-2
- fix poms, depmap frags

* Tue Jun 30 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.1.1-1.jpp5
- first release

